"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var stream_1 = require("stream");
var table_1 = require("table");
var chalk = require("chalk");
var Monit = (function (_super) {
    __extends(Monit, _super);
    function Monit(opts) {
        var _this = _super.call(this, { allowHalfOpen: false, objectMode: false, autoDestroy: true, highWaterMark: 16384 }) || this;
        var start = process.uptime();
        var interval = (opts === null || opts === void 0 ? void 0 : opts.interval) || 1;
        var transferred = 0;
        _this._transform = function (chunk, encoding, callback) {
            transferred += chunk.length;
            callback(null, chunk);
        };
        var lastWrited = 0;
        var lastReaded = 0;
        var isTTYDirty = false;
        var timer = setInterval(function () {
            var _a;
            var writed = transferred + _this.writableLength;
            var readed = transferred - _this.readableLength;
            var cached = writed - readed;
            var usedTime = process.uptime() - start;
            var writeSpeed = (writed - lastWrited) / interval;
            var readSpeed = (readed - lastReaded) / interval;
            lastWrited = writed;
            lastReaded = readed;
            if ((opts === null || opts === void 0 ? void 0 : opts.stdout) === false) {
                (_a = opts === null || opts === void 0 ? void 0 : opts.onTick) === null || _a === void 0 ? void 0 : _a.call(opts, writed, readed, usedTime);
                return;
            }
            if (isTTYDirty) {
                process.stdout.write("\x1B[u");
            }
            else {
                isTTYDirty = true;
                process.stdout.write("\x1B[s");
                process.stdout.write("\x1B[?25l");
                process.once("SIGINT", _this.onInterrupt);
            }
            process.stdout.write((0, table_1.table)([
                ["", chalk.blue("transferred size"), chalk.cyan("current speed")],
                ["readable => monit", "".concat(_this.format(writed), " ").concat(writed >= 1024 ? "(".concat(writed, ")") : ""), "".concat(_this.format(writeSpeed), "/s")],
                ["monit => writable", "".concat(_this.format(readed), " ").concat(readed >= 1024 ? "(".concat(readed, ")") : ""), "".concat(_this.format(readSpeed), "/s")],
                ["\u23F3 ".concat(chalk.magenta(Math.floor(usedTime)), " second since start"), "", ""],
                ["".concat(cached > 32768 ? "🟡" : "🟢", " internal buffer size: ").concat(cached > 32768 ? chalk.yellow(_this.format(cached)) : chalk.green(_this.format(cached))), "", ""],
            ], {
                columns: [{ alignment: "center" }, { alignment: "center" }, { alignment: "center" }],
                spanningCells: [
                    { row: 3, col: 0, colSpan: 3 },
                    { row: 4, col: 0, colSpan: 3 },
                ],
            }).replace(/\n/g, "\x1B[0K\n"));
        }, interval * 1000).unref();
        var showed = false;
        var showEndTable = function (error) {
            var _a;
            if (showed) {
                return;
            }
            showed = true;
            clearInterval(timer);
            var usedTime = process.uptime() - start;
            if ((opts === null || opts === void 0 ? void 0 : opts.stdout) === false) {
                (_a = opts === null || opts === void 0 ? void 0 : opts.onClose) === null || _a === void 0 ? void 0 : _a.call(opts, transferred, usedTime);
                return;
            }
            var averageSpeed = transferred / usedTime;
            process.stdout.write("\x1B[u");
            process.stdout.write("\x1B[0J");
            process.stdout.write((0, table_1.table)([
                [chalk.blue("transferred size"), chalk.magenta("used time"), chalk.cyan("average speed")],
                ["".concat(_this.format(transferred), " ").concat(transferred >= 1024 ? "(".concat(transferred, ")") : ""), "".concat(Math.floor(usedTime * 1000) / 1000, "s"), "".concat(_this.format(averageSpeed), "/s")],
                [error ? "\uD83D\uDD34 transfer fail! ".concat(error.message) : "\uD83D\uDFE2 transfer success!", "", ""],
            ], {
                columns: [{ alignment: "center" }, { alignment: "center" }, { alignment: "center" }],
                spanningCells: [{ row: 2, col: 0, colSpan: 3 }],
            }));
            process.stdout.write("\x1B[?25h");
            process.removeListener("SIGINT", _this.onInterrupt);
        };
        _this._flush = function (callback) {
            showEndTable(null);
            callback(null);
        };
        _this._destroy = function (error, callback) {
            showEndTable(error);
            callback(error);
        };
        return _this;
    }
    Monit.prototype.format = function (byte) {
        if (byte < 1024) {
            return "".concat(byte, " B");
        }
        if (byte < 1048576) {
            return "".concat(Math.round((byte / 1024) * 100) / 100, " KB");
        }
        if (byte < 1073741824) {
            return "".concat(Math.round((byte / 1048576) * 100) / 100, " MB");
        }
        return "".concat(Math.round((byte / 1073741824) * 100) / 100, " GB");
    };
    Monit.prototype.onInterrupt = function (signal) {
        process.stdout.write("\x1B[?25h");
        process.kill(process.pid, signal);
    };
    return Monit;
}(stream_1.Transform));
module.exports = function createMonit(opts) {
    return new Monit(opts);
};
